Subject: bug#53729: 29.0.50; Tamil text not shaped in modeline

From: Eli Zaretskii <[email-masked]>
Date: Sun, 13 Feb 2022 15:53:37 +0200

> From: Visuwesh <[email-masked]>
> Cc: [email-masked]
> Date: Thu, 10 Feb 2022 18:39:42 +0530
> 
> I tried all the Tamil fonts in Google fonts and to ease the checking
> process, I wrote the following Elisp snippet:
> 
>     (with-current-buffer (get-buffer-create "அக்னிச்சிறகுகள்.pdf")
>       (switch-to-buffer-other-window "அக்னிச்சிறகுகள்.pdf")
>       (let ((fonts '("Arima Madurai"
>                      "Baloo Thambi 2"
>                      "Catamaran"
>                      "Coiny"
>                      "Hind Madurai"
>                      "Kavivanar"
>                      "Meera Inimai"
>                      "Mukta Malar"
>                      "Oi"
>                      "Pavanam"
>                      "Noto Sans Tamil"
>                      "Noto Serif Tamil"
>                      "Lohit Tamil"))
>             (i 0)
>             (die nil))
>         (while (not die)
>           (erase-buffer)
>           (insert "அக்னிச்சிறகுகள்")
>           (set-fontset-font "fontset-default" 'tamil (cons (nth i fonts) "iso10646-1"))
>           (pcase (read-char-choice
>                   (format "%s ([n]ext, [p]rev, [q]uit): " (nth i fonts))
>                   '(?n ?q ?p))
>             (?q (setq die t))
>             (?n (setq i (mod (1+ i) (length fonts))))
>             (?p (setq i (mod (1- i) (length fonts))))))))
> 
> and the buffer name in the modeline has the right shaping!  This is the
> case for _every_ font I tried: including Noto Serif Tamil.  But if I
> open a file named "அக்னிச்சிறகுகள்.pdf", the shaping is as in the OP.

What happens if you turn off auto-composition mode before repeating
the above experiment?  Do you see any difference in the buffer name
produced by you and the buffer name produced by Emacs when visiting
that file?